use half::bf16;
use half::f16;
///Maps all tensorflow DataTypes to rust types
use tensorflow::DataType;
//derive into for all native rust types and bf16 and f16 from half crate
//impl Into<DataType> for f32 {
//    fn into(self) -> DataType {
//        DataType::Float
//    }
//}
//impl Into<DataType> for f64 {
//    fn into(self) -> DataType {
//        DataType::Double
//    }
//}
//impl Into<DataType> for i32 {
//    fn into(self) -> DataType {
//        DataType::Int32
//    }
//}
//impl Into<DataType> for u8 {
//    fn into(self) -> DataType {
//        DataType::UInt8
//    }
//}
//impl Into<DataType> for i16 {
//    fn into(self) -> DataType {
//        DataType::Int16
//    }
//}
//impl Into<DataType> for i8 {
//    fn into(self) -> DataType {
//        DataType::Int8
//    }
//}
//impl Into<DataType> for String {
//    fn into(self) -> DataType {
//        DataType::String
//    }
//}
//impl Into<DataType> for i64 {
//    fn into(self) -> DataType {
//        DataType::Int64
//    }
//}
//impl Into<DataType> for bool {
//    fn into(self) -> DataType {
//        DataType::Bool
//    }
//}
//impl Into<DataType> for u16 {
//    fn into(self) -> DataType {
//        DataType::Uint16
//    }
//}
//impl Into<DataType> for u32 {
//    fn into(self) -> DataType {
//        DataType::Uint32
//    }
//}
//impl Into<DataType> for u64 {
//    fn into(self) -> DataType {
//        DataType::Uint64
//    }
//}
//NOTE: conflicting implemntations with upstream Tensorflow-rs
//impl Into<DataType> for i8 {
//    fn into(self) -> DataType {
//        DataType::Qint8
//    }
//}
//impl Into<DataType> for bf16 {
//    fn into(self) -> DataType {
//        DataType::Bfloat16
//    }
//}
//impl Into<DataType> for f16 {
//    fn into(self) -> DataType {
//        DataType::Half
//    }
//}
//
//also implement From for all native rust types and bf16 and f16 from half crate
//impl From<f32> for DataType {
//    fn from(_: f32) -> DataType {
//        DataType::Float
//    }
//}
//impl From<f64> for DataType {
//    fn from(_: f64) -> DataType {
//        DataType::Double
//    }
//}
//impl From<i32> for DataType {
//    fn from(_: i32) -> DataType {
//        DataType::Int32
//    }
//}
//impl From<u8> for DataType {
//    fn from(_: u8) -> DataType {
//        DataType::UInt8
//    }
//}
//impl From<i16> for DataType {
//    fn from(_: i16) -> DataType {
//        DataType::Int16
//    }
//}
//impl From<i8> for DataType {
//    fn from(_: i8) -> DataType {
//        DataType::Int8
//    }
//}
//impl From<String> for DataType {
//    fn from(_: String) -> DataType {
//        DataType::String
//    }
//}
//impl From<i64> for DataType {
//    fn from(_: i64) -> DataType {
//        DataType::Int64
//    }
//}
//impl From<bool> for DataType {
//    fn from(_: bool) -> DataType {
//        DataType::Bool
//    }
//}
//impl From<u16> for DataType {
//    fn from(_: u16) -> DataType {
//        DataType::Uint16
//    }
//}
//impl From<u32> for DataType {
//    fn from(_: u32) -> DataType {
//        DataType::Uint32
//    }
//}
//impl From<u64> for DataType {
//    fn from(_: u64) -> DataType {
//        DataType::Uint64
//    }
//}
//instead of a trait, create functions that map from DataType to rust types using a macro, dont
pub fn LossyBfloatCast(T: DataType, value: f32) -> bf16 {
    if DataType::BFloat16 == T {
        bf16::from_f32(value)
    } else {
        panic!("LossyBfloatCast: DataType is not BFloat16")
    }
}
pub fn LossyFloatCast(T: DataType, value: f32) -> f32 {
    if DataType::Float == T {
        value
    } else {
        panic!("LossyFloatCast: DataType is not Float")
    }
}
//instead use a match
pub fn LossyCast<U>(T: DataType, value: f32) -> U
where
    U: From<f32>,
{
    match T {
        DataType::Float => U::from(value) as f32,
        DataType::BFloat16 => U::from(value),
        _ => panic!("LossyCast: DataType is not Float or BFloat16"),
    }
}
